<?php
/**
 * Action supprimer pour l'objet carte_territoires.
 */
if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

/**
 * Action pour supprimer une carte_territoires.
 *
 * @param null|int $arg Identifiant à supprimer.
 *                      En absence de l'id l'action utilise l'argument sécurisée.
 *
 * @return void
**/
function action_supprimer_carte_territoires_dist(?int $arg = null) : void {
	$need_confirm = false;
	if (null === $arg) {
		$securiser_action = charger_fonction('securiser_action', 'inc');
		$arg = $securiser_action();
		$need_confirm = true;
	}
	$arg = (int) $arg;

	if ($need_confirm) {
		$ok = confirmer_supprimer_carte_territoires_avant_action(_T('carte_territoires:confirmer_supprimer_carte_territoires'), _T('item_oui') . '! ' . _T('carte_territoires:supprimer_carte_territoires'));
	}

	// cas suppression
	if (autoriser('supprimer', 'carte_territoires', $arg)) {
		if ($arg) {
			$objet = sql_fetsel('*', 'spip_cartes_territoires', 'id_carte=' . sql_quote($arg));
			$qui = (!empty($GLOBALS['visiteur_session']['id_auteur']) ? 'auteur #' . $GLOBALS['visiteur_session']['id_auteur'] : 'IP ' . $GLOBALS['ip']);
			spip_log("SUPPRESSION carte_territoires#{$arg} par {$qui} : " . json_encode($objet), 'suppressions' . _LOG_INFO_IMPORTANTE);

			sql_delete('spip_cartes_territoires', 'id_carte=' . sql_quote($arg));

			// invalider le cache
			include_spip('inc/invalideur');
			suivre_invalideur("id='carte_territoires/{$arg}'");
		} else {
			spip_log("action_supprimer_carte_territoires_dist {$arg} pas compris");
		}
	}
}

/**
 * Confirmer avant suppression si on arrive par un bouton action.
 *
 * @param string      $titre
 * @param string      $titre_bouton
 * @param null|string $url_action
 *
 * @return bool
 */
function confirmer_supprimer_carte_territoires_avant_action($titre, $titre_bouton, $url_action = null) {
	if (!$url_action) {
		$url_action = self();
		$action = _request('action');
		$url_action = parametre_url($url_action, 'action', $action, '&');
	} else {
		$action = parametre_url($url_action, 'action');
	}
	$arg = parametre_url($url_action, 'arg');
	$confirm = md5("{$action}:{$arg}:" . realpath(__FILE__));
	if (_request('confirm_action') === $confirm) {
		return true;
	}

	$url_confirm = parametre_url($url_action, 'confirm_action', $confirm, '&');
	include_spip('inc/filtres');
	$bouton_action = bouton_action($titre_bouton, $url_confirm);
	$corps = "<div style='text-align:center;'>{$bouton_action}</div>";

	include_spip('inc/minipres');
	echo minipres($titre, $corps);
	exit;
}
