<?php
/**
 * Utilisations de pipelines par Cartes.
 *
 * @plugin     Cartes
 *
 * @copyright  2021
 * @author     Eric Lupinacci
 *
 * @licence    GNU/GPL
 *
 * @package    SPIP\Cartes\Pipelines
 */
if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

/**
 * Optimiser la base de données.
 *
 * Supprime les liens orphelins de l'objet vers quelqu'un et de quelqu'un vers l'objet.
 *
 * @pipeline optimiser_base_disparus
 *
 * @param array $flux Données du pipeline
 *
 * @return array Données du pipeline
 */
function cartes_territoires_optimiser_base_disparus($flux) {
	include_spip('action/editer_liens');
	$flux['data'] += objet_optimiser_liens(['carte_territoires' => '*'], '*');

	return $flux;
}


/**
 * Enlever id_carte de la table spip_territoires du critère selections conditionnelles,
 *
 * @param array $flux
 * @return array
 */
function cartes_territoires_exclure_id_conditionnel(array $flux) : array {
	if (
		in_array(
			$flux['args']['table'],
			['spip_territoires']
		)
	) {
		$flux['data'] = array_merge($flux['data'], ['id_carte']);
	}
	return $flux;
}
